#|
 This file is a part of Colleen
 (c) 2014 Shirakumo http://tymoon.eu (shinmera@tymoon.eu)
 Author: Nicolas Hafner <shinmera@tymoon.eu>
|#

(in-package #:org.shirakumo.colleen)
(defpackage #:org.shirakumo.colleen.mod.markov-twitter-bridge
  (:nicknames #:co-markov-twitter-bridge)
  (:use #:cl #:colleen #:events))
(in-package #:org.shirakumo.colleen.mod.markov-twitter-bridge)

(define-module markov-twitter-bridge () ()
  (:documentation "A very simple module that outputs a string generated by the markov module every now and again."))

(defmethod start ((mod markov-twitter-bridge))
  (with-module-thread (mod)
    (loop do (sleep (+ (* 60 15) (random (* 8 (* 60 60)))))
             (markov-tweet))))

(define-command markov-tweet () (:documentation "Tweets a markov message.")
  (respond event "The birds sing: ~a" (markov-tweet)))

(defun markov-tweet ()
  (let ((message (loop for msg = (co-markov:generate-string)
                       until (<= (length msg) 140)
                       finally (return msg))))
    (chirp:tweet message)
    message))
